globals
[
  learning-days zone-size zone-coefficient L
  sta-a-xcor sta-a-ycor sta-b-xcor sta-b-ycor
  hw-ycor hw-westend-xcor hw-eastend-xcor
  v-walk v-bicycle v-car v-train v-car-hwghway v-min-car v-tram
  f-walk f-bicycle f-car f-train f-tram
  p-remove c-remove c-bicycleparking c-parking c-train-fare c-fuel eta-t
  d0 f-max-congestion eta-congestion eta-r
  alpha gamma
  days area candidate-list
  size-of-home count-of-moving
  center-of-house-xcor center-of-house-ycor sd-of-house-xcor sd-of-house-ycor
  habitation-selection-flag candidate-i
  facility-xcor facility-ycor
  f-tram-xcor f-tram-ycor
  f-tram-line-num
  ratio-walk ratio-bike ratio-train ratio-car ratio-train+tram ratio-tram
  bst-impact-dist
  tram-sta-2-xcor
  tram-sta-2-ycor
  tram-sta-3-xcor
  tram-sta-3-ycor
  tram-sta-5-xcor
  tram-sta-5-ycor
  list-of-ltn0 list-of-ltn1 list-of-ltn2 list-of-ltn3 list-of-ltn4 list-of-ltn5 list-of-ltn6 list-of-ltn7 list-of-ltn8 list-of-ltn9
  coeff-for-sd-of-h
  sprawl-limit
  rate-d
  initial-epsilon
  max-commuting-time
  list-of-car-moving list-of-train-moving list-of-tram-moving
  list-of-t-total
  list-of-center-xcor list-of-center-ycor
  list-of-sd-xcor list-of-sd-ycor

  sum-car-travel
  sum-train-travel
  sum-tram-travel
  CO2-emission

  n-people
  day-learn
  n-relocation
  n-candidate
  fuel-cost

  initial-state
  ;park&walk
  p-radius
  ;bicycle-promotion
  coeff-velocity
  coeff-fatigue
  tram
]

turtles-own
[
  house-xcor house-ycor destination-xcor destination-ycor
  temporary-num-h temporary-num-d
  linked-trip-number vlist step arrival-at-destination
  train-flag bicycleparking-flag parking-flag
  t-total t-walk t-bicycle t-car t-train t-tram
  t-tram-for-keep
  f-congestion
  bustle-degree
  start-time-list
  cost c-money c-time c-fatigue
  house-prediction-cost house-prediction-cost-list
  house-candidate-xcor house-candidate-ycor
  min-prediction-cost-number
  moving-candidate
  my-t-type
  dist-car
  my-velocity
  my-arrival-flag
  my-dest-xcor my-dest-ycor
  my-parking-xcor my-parking-ycor
  my-h-tram-xcor my-h-tram-ycor
  my-d-tram-xcor my-d-tram-ycor
  my-h-tram-line-num
  my-d-tram-line-num
  my-car-moving
  my-train-moving
  my-tram-moving
  temp-t-total-list final-t-total
  t-around-f
  epsilon
  tram-line-num
  tram-sta-num
  departure-from-home-check
  arrival-at-office-check
  departure-from-office-check
  arrival-at-facility-check
  departure-from-facility-check
  my-home-delay
  my-home-departure-time
  my-office-delay
  my-office-arrival-time
  my-office-departure-time
  temporary-my-facility-delay
  my-facility-delay
  my-facility-departure-time
  my-commuting-time
  my-commuting-time-count-check
  skip-check
]

breed [people person]
breed [parkings parking]
breed [tram-stas tram-sta]

to setup
  clear-all
  setup-parameters
  setup-patches
  setup-turtles
  reset-ticks
end

to setup-parameters
  set zone-size 8
  set zone-coefficient 1
  set L 40

  set alpha 0.5
  set gamma 0.94
  set initial-epsilon 0.7

  set initial-state "zoned"
  ;set park&walk "no"
  set p-radius 15
  ;set bicycle-promotion "no"
  set coeff-velocity 1.2
  set coeff-fatigue 0.5
  set tram "no"

  set v-walk 2 / 3 ;4km/h=66.67m/min
  ifelse bicycle-promotion = "yes" [
    set v-bicycle 2 * coeff-velocity ;12km/h=200m/min
  ][
    set v-bicycle 2
  ]
  set v-train (L / 7 + 3.5) ;(L/7+350)m/min=4000/7+350=921m/min=55.3km/h
  set v-car 4 ;24km/h=400m/min
  set v-car-hwghway 10 ;60km/h=1000m/min
  set v-tram 2 ;12km/h=200m/min

  set eta-t 50
  set c-bicycleparking 150
  set c-parking 800
  set c-train-fare L * 4 ;4yen/100m (0.04yen/m)
  set c-fuel 1.5 ;1.5yen/100m (0.015yen/m)

  set f-walk 180
  ifelse bicycle-promotion = "yes" [
    set f-bicycle 420 * coeff-fatigue
  ][
    set f-bicycle 420
  ]
  set f-car 60
  set f-train 60
  set f-tram 60
  set d0 1
  set bst-impact-dist 5

  set eta-r 1000
  set size-of-home 0.014
  set area 1

  set coeff-for-sd-of-h 2
  set sprawl-limit 5
  set rate-d 10

  set n-people 1000
  set day-learn 30
  set n-relocation 20
  set n-candidate 10
  set fuel-cost 1

  set list-of-ltn0 n-values n-relocation [0]
  set list-of-ltn1 n-values n-relocation [0]
  set list-of-ltn2 n-values n-relocation [0]
  set list-of-ltn3 n-values n-relocation [0]
  set list-of-ltn4 n-values n-relocation [0]
  set list-of-ltn5 n-values n-relocation [0]
  set list-of-ltn6 n-values n-relocation [0]
  set list-of-ltn7 n-values n-relocation [0]
  set list-of-ltn8 n-values n-relocation [0]
  set list-of-ltn9 n-values n-relocation [0]
  set list-of-car-moving n-values n-relocation [0]
  set list-of-train-moving n-values n-relocation [0]
  set list-of-tram-moving n-values n-relocation [0]
  set list-of-t-total n-values n-relocation [0]
  set list-of-center-xcor n-values n-relocation [0]
  set list-of-center-ycor n-values n-relocation [0]
  set list-of-sd-xcor n-values n-relocation [0]
  set list-of-sd-ycor n-values n-relocation [0]

  if initial-state = "zoned" [
    set CO2-emission (n-people * L * 2 * 2.0) / (63169.1778463323 * 14.5 + 5870 * 2.0 * n-people / 1000)
    set center-of-house-xcor -20
    set center-of-house-ycor 0
    set sd-of-house-xcor 8
    set sd-of-house-ycor 8
  ]
  if initial-state = "sprawled" [
    set CO2-emission 1
    set center-of-house-xcor -1.00906469776476
    set center-of-house-ycor 2.40158134824873
    set sd-of-house-xcor 22.9446557241052
    set sd-of-house-ycor 9.81373268893356
  ]
end


to setup-patches
  set sta-a-xcor -1 * L / 2
  set sta-a-ycor 0
  set sta-b-xcor L / 2
  set sta-b-ycor 0

  ifelse park&walk = "no" [
      set hw-ycor 5
  ][
    set hw-ycor p-radius
  ]

  set hw-westend-xcor -1 * max-pxcor
  set hw-eastend-xcor max-pxcor

  if OFS-location = "B: suburb-hw" [
    set facility-xcor sta-b-xcor + 20
    set facility-ycor hw-ycor
  ]
  if OFS-location = "C: suburb" [
    set facility-xcor sta-b-xcor + (15 - 0.000001)
    set facility-ycor sta-b-ycor - 15
  ]
  if OFS-location = "D: same-sta" [
    set facility-xcor sta-b-xcor - 0.000001
    set facility-ycor sta-b-ycor
  ]
  if OFS-location = "E: near-sta" [
    ifelse tram = "yes"[
    ][
      set facility-xcor sta-b-xcor + (5 - 0.000001)
      set facility-ycor sta-b-ycor - 5
    ]
  ]
  if OFS-location = "by-slider" [
    set facility-xcor sta-b-xcor + OFS-xcor * 10 - 0.000001
    set facility-ycor sta-b-ycor + OFS-ycor * 10
  ]

  if OFS-location != "A: no" [
    ask patch facility-xcor facility-ycor [set pcolor red]
  ]

  ask patches with [(pxcor >= hw-westend-xcor) and (pxcor <= hw-eastend-xcor) and ( pycor = hw-ycor)] [set pcolor 52]
  ask patches with [(pxcor >= sta-a-xcor) and (pxcor <= sta-b-xcor) and ( pycor = sta-a-ycor)] [set pcolor 12]
  ask patch sta-a-xcor sta-a-ycor [set pcolor red]
  ask patch sta-b-xcor sta-b-ycor [set pcolor red]

end


to setup-turtles
  set-default-shape people "person"
  set-default-shape parkings "circle"
  set-default-shape tram-stas "square"

  let zone-size-s zone-size * zone-coefficient

  if initial-state = "zoned" [
    create-people n-people [
      set house-xcor (limited-random-xcor sta-a-xcor zone-size-s)
      set house-ycor (limited-random-ycor sta-a-ycor zone-size-s)
      set destination-xcor (limited-random-xcor sta-b-xcor zone-size-s)
      set destination-ycor (limited-random-ycor sta-b-ycor zone-size-s)
      ifelse tram = "yes" [
        let limit-prob random 4
      ][
        let limit-prob random 2
        if limit-prob = 0 [set linked-trip-number 2]
        if limit-prob = 1 [set linked-trip-number 3]
      ]
      set vlist n-values 10 [-99999999]
      set epsilon initial-epsilon
    ]

    proximity-house
    ask people [setxy 99 99]
    proximity-destination
    ask people [setxy 99 99]
  ]

  if initial-state = "sprawled" [

    if park&walk = "yes"[
      ask people with [linked-trip-number = 4 or linked-trip-number = 5] [
        if ((((sta-b-xcor - house-xcor) ^ 2) + ((sta-b-ycor - house-ycor) ^ 2)) ^ 0.5) < (p-radius + 1) [
          set linked-trip-number random 4
        ]
      ]
    ]
  ]

  ask people [
    set color white
    set size 1

    setxy house-xcor house-ycor

    set departure-from-home-check 0
    set arrival-at-office-check 0
    set departure-from-office-check 0
    set departure-from-facility-check 0

    set step 0
    set start-time-list n-values 30 [0]

    set t-walk 0
    set t-bicycle 0
    set t-car 0
    set t-train 0
    set t-tram 0

    set my-home-delay min (list (abs (round (random-normal 12 3))) 20)
    set my-office-delay min (list (abs (round (random-normal 12 3))) 20)
    set my-facility-delay 0

    set my-commuting-time-count-check 0

    ask patch house-xcor house-ycor [set pcolor green]
    ask patch destination-xcor destination-ycor [set pcolor blue]

    set house-candidate-xcor n-values n-candidate [0]
    set house-candidate-ycor n-values n-candidate [0]
  ]

  if park&walk = "yes" [
    create-parkings 10 [set color yellow]
    layout-circle parkings p-radius
    ask parkings [
      set xcor xcor + 20
    ]
  ]

  if tram = "yes" [

  ]

  if people-fig = "invisible" [
    ask people [hide-turtle]
  ]

  let ltn0 count people with [linked-trip-number = 0]
  let ltn1 count people with [linked-trip-number = 1]
  let ltn2 count people with [linked-trip-number = 2]
  let ltn3 count people with [linked-trip-number = 3]
  let ltn4 count people with [linked-trip-number = 4]
  let ltn5 count people with [linked-trip-number = 5]
  let ltn6 count people with [linked-trip-number = 6]
  let ltn7 count people with [linked-trip-number = 7]
  let ltn8 count people with [linked-trip-number = 8]
  let ltn9 count people with [linked-trip-number = 9]
  set ratio-walk (ltn0) / n-people
  set ratio-bike (ltn1) / n-people
  set ratio-train (ltn2 + ltn3) / n-people
  set ratio-car (ltn4 + ltn5) / n-people
  set ratio-train+tram (ltn6 + ltn7) / n-people
  set ratio-tram (ltn8 + ltn9) / n-people

end

to proximity-house
  let zone-size-s zone-size * zone-coefficient
  ask people [
    setxy house-xcor house-ycor
    set temporary-num-h count people in-radius sprawl-limit
  ]
  while [count people with [temporary-num-h <= 3] > 0] [
    ask people with [temporary-num-h <= 3] [
      set house-xcor (limited-random-xcor sta-a-xcor zone-size-s)
      set house-ycor (limited-random-ycor sta-a-ycor zone-size-s)
      setxy house-xcor house-ycor
      set temporary-num-h count people in-radius sprawl-limit
    ]
  ]
end

to proximity-destination
  let zone-size-s zone-size * zone-coefficient
  ask people [
    setxy destination-xcor destination-ycor
    set temporary-num-d count people in-radius sprawl-limit
  ]
  while [count people with [temporary-num-d <= 3] > 0] [
    ask people with [temporary-num-d <= 3] [
      set destination-xcor (limited-random-xcor sta-b-xcor zone-size-s)
      set destination-ycor (limited-random-ycor sta-b-ycor zone-size-s)
      setxy destination-xcor destination-ycor
      set temporary-num-d count people in-radius sprawl-limit
    ]
  ]
end

to-report limited-random-xcor [m d]
  report max(list (-1 * max-pxcor) min(list max-pxcor random-normal m d))
end

to-report limited-random-ycor [m d]
  report max(list (-1 * max-pycor) min(list max-pycor random-normal m d))
end

to go
  if park&walk = "yes" and tram = "yes"  [

  ]
  if count-of-moving >= n-relocation [
    stop
  ]
  linked-trip-of-people
  habitation-selection
  tick
end

to linked-trip-of-people
  if days < day-learn [
    ask people [
      linked-trip "no-house-search"
    ]
    arrival-check "no-house-search"

    let ltn0 count people with [linked-trip-number = 0]
    let ltn1 count people with [linked-trip-number = 1]
    let ltn2 count people with [linked-trip-number = 2]
    let ltn3 count people with [linked-trip-number = 3]
    let ltn4 count people with [linked-trip-number = 4]
    let ltn5 count people with [linked-trip-number = 5]
    let ltn6 count people with [linked-trip-number = 6]
    let ltn7 count people with [linked-trip-number = 7]
    let ltn8 count people with [linked-trip-number = 8]
    let ltn9 count people with [linked-trip-number = 9]
    set ratio-walk (ltn0) / n-people
    set ratio-bike (ltn1) / n-people
    set ratio-train (ltn2 + ltn3) / n-people
    set ratio-car (ltn4 + ltn5) / n-people
    set ratio-train+tram (ltn6 + ltn7) / n-people
    set ratio-tram (ltn8 + ltn9) / n-people
  ]
end

to linked-trip [house-search]
  if OFS-location = "A: no" [
    if linked-trip-number = 0 [
      if step = 0 [unlinked-trip "home" 0 0 0 0 0 0 0 0]
      if step = 1 [unlinked-trip "walk" v-walk destination-xcor destination-ycor 0 0 0 0 0]
      if step = 2 [unlinked-trip "office-a" 0 0 0 0 0 0 0 1]
      if step = 3 [unlinked-trip "office-d" 0 0 0 0 0 0 0 1]
      if step = 4 [unlinked-trip "walk" v-walk house-xcor house-ycor 0 0 0 0 3]
    ]

    if linked-trip-number = 1 [
      if step = 0 [unlinked-trip "home" 0 0 0 0 0 0 0 0]
      if step = 1 [unlinked-trip "bicycle" v-bicycle destination-xcor destination-ycor 0 1 0 0 0]
      if step = 2 [unlinked-trip "office-a" 0 0 0 0 0 0 0 1]
      if step = 3 [unlinked-trip "office-d" 0 0 0 0 0 0 0 1]
      if step = 4 [unlinked-trip "bicycle" v-bicycle house-xcor house-ycor 0 0 0 0 3]
    ]

    if linked-trip-number = 2 [
      if step = 0 [unlinked-trip "home" 0 0 0 0 0 0 0 0]
      if step = 1 [unlinked-trip "walk" v-walk sta-a-xcor sta-a-ycor 0 0 0 0 0]
      if step = 2 [unlinked-trip "train" v-train sta-b-xcor sta-b-ycor 1 0 0 0 0]
      if step = 3 [unlinked-trip "walk" v-walk destination-xcor destination-ycor 0 0 0 0 0]
      if step = 4 [unlinked-trip "office-a" 0 0 0 0 0 0 0 1]
      if step = 5 [unlinked-trip "office-d" 0 0 0 0 0 0 0 1]
      if step = 6 [unlinked-trip "walk" v-walk sta-b-xcor sta-b-ycor 0 0 0 0 1]
      if step = 7 [unlinked-trip "train" v-train sta-a-xcor sta-a-ycor 1 0 0 0 1]
      if step = 8 [unlinked-trip "walk" v-walk house-xcor house-ycor 0 0 0 0 3]
    ]

    if linked-trip-number = 3 [
      if step = 0 [unlinked-trip "home" 0 0 0 0 0 0 0 0]
      if step = 1 [unlinked-trip "bicycle" v-bicycle sta-a-xcor sta-a-ycor 0 1 0 0 0]
      if step = 2 [unlinked-trip "train" v-train sta-b-xcor sta-b-ycor 1 0 0 0 0]
      if step = 3 [
        ifelse bicycle-promotion = "no" [
          unlinked-trip "walk" v-walk destination-xcor destination-ycor 0 0 0 0 0
        ][
          unlinked-trip "bicycle" v-bicycle destination-xcor destination-ycor 0 0 0 0 0
        ]
      ]
      if step = 4 [unlinked-trip "office-a" 0 0 0 0 0 0 0 1]
      if step = 5 [unlinked-trip "office-d" 0 0 0 0 0 0 0 1]
      if step = 6 [
        ifelse bicycle-promotion = "no" [
          unlinked-trip "walk" v-walk sta-b-xcor sta-b-ycor 0 0 0 0 1
        ][
          unlinked-trip "bicycle" v-bicycle sta-b-xcor sta-b-ycor 0 0 0 0 1
        ]
      ]
      if step = 7 [unlinked-trip "train" v-train sta-a-xcor sta-a-ycor 0 1 0 0 1]
      if step = 8 [unlinked-trip "bicycle" v-bicycle house-xcor house-ycor 0 0 0 0 3]
    ]

    if linked-trip-number = 4 [
      if park&walk = "no" [
        if step = 0 [unlinked-trip "home" 0 0 0 0 0 0 0 0]
        if step = 1 [unlinked-trip "car" v-car destination-xcor destination-ycor 0 0 1 1 0]
        if step = 2 [unlinked-trip "office-a" 0 0 0 0 0 0 0 1]
        if step = 3 [unlinked-trip "office-d" 0 0 0 0 0 0 0 1]
        if step = 4 [unlinked-trip "car" v-car house-xcor house-ycor 0 0 0 1 3]
        let dist-car-4-0 ((destination-xcor - house-xcor) ^ 2 + (destination-ycor - house-ycor) ^ 2) ^ 0.5
        let dist-car-4-2 ((house-xcor - destination-xcor) ^ 2 + (house-ycor - destination-ycor) ^ 2) ^ 0.5
        set dist-car dist-car-4-0 + dist-car-4-2
      ]
      if park&walk = "yes" [
        let closest min-one-of parkings [distancexy [destination-xcor] of myself [destination-ycor] of myself]
        set my-parking-xcor [xcor] of closest
        set my-parking-ycor [ycor] of closest
        if step = 0 [unlinked-trip "home" 0 0 0 0 0 0 0 0]
        if step = 1 [unlinked-trip "car" v-car my-parking-xcor my-parking-ycor 0 0 1 1 0]
        if step = 2 [unlinked-trip "walk" v-walk destination-xcor destination-ycor 0 0 0 0 0]
        if step = 3 [unlinked-trip "office-a" 0 0 0 0 0 0 0 1]
        if step = 4 [unlinked-trip "office-d" 0 0 0 0 0 0 0 1]
        if step = 5 [unlinked-trip "walk" v-walk my-parking-xcor my-parking-ycor 0 0 0 3 1]
        if step = 6 [unlinked-trip "car" v-car house-xcor house-ycor 0 0 0 1 3]
        let dist-car-4-0 ((my-parking-xcor - house-xcor) ^ 2 + (my-parking-ycor - house-ycor) ^ 2) ^ 0.5
        let dist-car-4-4 ((house-xcor - my-parking-xcor) ^ 2 + (house-ycor - my-parking-ycor) ^ 2) ^ 0.5
        set dist-car dist-car-4-0 + dist-car-4-4
      ]
    ]

    if linked-trip-number = 5 [
      if park&walk = "no" [
        if step = 0 [unlinked-trip "home" 0 0 0 0 0 0 0 0]
        if step = 1 [unlinked-trip "car" v-car house-xcor hw-ycor 0 0 0 1 0]
        if step = 2 [unlinked-trip "car-hw" v-car-hwghway destination-xcor hw-ycor 0 0 0 2 0]
        if step = 3 [unlinked-trip "car" v-car destination-xcor destination-ycor 0 0 1 1 0]
        if step = 4 [unlinked-trip "office-a" 0 0 0 0 0 0 0 1]
        if step = 5 [unlinked-trip "office-d" 0 0 0 0 0 0 0 1]
        if step = 6 [unlinked-trip "car" v-car destination-xcor hw-ycor 0 0 0 1 1]
        if step = 7 [unlinked-trip "car-hw" v-car-hwghway house-xcor hw-ycor 0 0 0 2 1]
        if step = 8 [unlinked-trip "car" v-car house-xcor house-ycor 0 0 0 1 3]
        let dist-car-5-0 ((house-xcor - house-xcor) ^ 2 + (hw-ycor - house-ycor) ^ 2) ^ 0.5
        let dist-car-5-1 ((destination-xcor - house-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
        let dist-car-5-2 ((destination-xcor - destination-xcor) ^ 2 + (destination-ycor - hw-ycor) ^ 2) ^ 0.5
        let dist-car-5-4 ((destination-xcor - destination-xcor) ^ 2 + (hw-ycor - destination-ycor) ^ 2) ^ 0.5
        let dist-car-5-5 ((house-xcor - destination-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
        let dist-car-5-6 ((house-xcor - house-xcor) ^ 2 + (house-ycor - hw-ycor) ^ 2) ^ 0.5
        set dist-car dist-car-5-0 + dist-car-5-1 + dist-car-5-2 + dist-car-5-4 + dist-car-5-5 + dist-car-5-6
      ]
      if park&walk = "yes" [
        let closest min-one-of parkings [distancexy [destination-xcor] of myself [destination-ycor] of myself]
        set my-parking-xcor [xcor] of closest
        set my-parking-ycor [ycor] of closest
        if step = 0 [unlinked-trip "home" 0 0 0 0 0 0 0 0]
        if step = 1 [unlinked-trip "car" v-car house-xcor hw-ycor 0 0 0 1 0]
        if step = 2 [unlinked-trip "car-hw" v-car-hwghway my-parking-xcor hw-ycor 0 0 0 2 0]
        if step = 3 [unlinked-trip "car" v-car my-parking-xcor my-parking-ycor 0 0 1 1 0]
        if step = 4 [unlinked-trip "walk" v-walk destination-xcor destination-ycor 0 0 0 0 0]
        if step = 5 [unlinked-trip "office-a" 0 0 0 0 0 0 0 1]
        if step = 6 [unlinked-trip "office-d" 0 0 0 0 0 0 0 1]
        if step = 7 [unlinked-trip "walk" v-walk my-parking-xcor my-parking-ycor 0 0 0 0 1]
        if step = 8 [unlinked-trip "car" v-car my-parking-xcor hw-ycor 0 0 0 1 1]
        if step = 9 [unlinked-trip "car-hw" v-car-hwghway house-xcor hw-ycor 0 0 0 2 1]
        if step = 10 [unlinked-trip "car" v-car house-xcor house-ycor 0 0 0 1 3]
        let dist-car-5-0 ((house-xcor - house-xcor) ^ 2 + (hw-ycor - house-ycor) ^ 2) ^ 0.5
        let dist-car-5-1 ((my-parking-xcor - house-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
        let dist-car-5-2 ((my-parking-xcor - my-parking-xcor) ^ 2 + (my-parking-ycor - hw-ycor) ^ 2) ^ 0.5
        let dist-car-5-6 ((my-parking-xcor - my-parking-xcor) ^ 2 + (hw-ycor - my-parking-ycor) ^ 2) ^ 0.5
        let dist-car-5-7 ((house-xcor - my-parking-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
        let dist-car-5-8 ((house-xcor - house-xcor) ^ 2 + (house-ycor - hw-ycor) ^ 2) ^ 0.5
        set dist-car dist-car-5-0 + dist-car-5-1 + dist-car-5-2 + dist-car-5-6 + dist-car-5-7 + dist-car-5-8
      ]
    ]

    if (linked-trip-number = 6 or linked-trip-number = 7) [

    ]

    if linked-trip-number = 8 or linked-trip-number = 9 [

    ]
  ]

  if OFS-location != "A: no" [
    if linked-trip-number = 0 [
      if step = 0 [unlinked-trip "home" 0 0 0 0 0 0 0 0]
      if step = 1 [unlinked-trip "walk" v-walk destination-xcor destination-ycor 0 0 0 0 0]
      if step = 2 [unlinked-trip "office-a" 0 0 0 0 0 0 0 1]
      if step = 3 [unlinked-trip "office-d" 0 0 0 0 0 0 0 1]
      if step = 4 [unlinked-trip "walk" v-walk facility-xcor facility-ycor 0 0 0 3 1]
      if step = 5 [unlinked-trip "facility-a" 0 0 0 0 0 0 0 1]
      if step = 6 [unlinked-trip "facility-d" 0 0 0 0 0 0 0 1]
      if step = 7 [unlinked-trip "walk" v-walk house-xcor house-ycor 0 0 0 3 3]
    ]

    if linked-trip-number = 1 [
      if step = 0 [unlinked-trip "home" 0 0 0 0 0 0 0 0]
      if step = 1 [unlinked-trip "bicycle" v-bicycle destination-xcor destination-ycor 0 1 0 0 0]
      if step = 2 [unlinked-trip "office-a" 0 0 0 0 0 0 0 1]
      if step = 3 [unlinked-trip "office-d" 0 0 0 0 0 0 0 1]
      if step = 4 [unlinked-trip "bicycle" v-bicycle facility-xcor facility-ycor 0 0 0 3 1]
      if step = 5 [unlinked-trip "facility-a" 0 0 0 0 0 0 0 1]
      if step = 6 [unlinked-trip "facility-d" 0 0 0 0 0 0 0 1]
      if step = 7 [unlinked-trip "bicycle" v-bicycle house-xcor house-ycor 0 0 0 3 3]
    ]

    if linked-trip-number = 2 [
      if step = 0 [unlinked-trip "home" 0 0 0 0 0 0 0 0]
      if step = 1 [unlinked-trip "walk" v-walk sta-a-xcor sta-a-ycor 0 0 0 0 0]
      if step = 2 [unlinked-trip "train" v-train sta-b-xcor sta-b-ycor 1 0 0 0 0]
      if step = 3 [unlinked-trip "walk" v-walk destination-xcor destination-ycor 0 0 0 0 0]
      if step = 4 [unlinked-trip "office-a" 0 0 0 0 0 0 0 1]
      if step = 5 [unlinked-trip "office-d" 0 0 0 0 0 0 0 1]
      if step = 6 [unlinked-trip "walk" v-walk facility-xcor facility-ycor 0 0 0 3 1]
      if step = 7 [unlinked-trip "facility-a" 0 0 0 0 0 0 0 1]
      if step = 8 [unlinked-trip "facility-d" 0 0 0 0 0 0 0 1]
      if step = 9 [unlinked-trip "walk" v-walk sta-b-xcor sta-b-ycor 0 0 0 3 2]
      if step = 10 [unlinked-trip "train" v-train sta-a-xcor sta-a-ycor 1 0 0 0 2]
      if step = 11 [unlinked-trip "walk" v-walk house-xcor house-ycor 0 0 0 0 3]
    ]

    if linked-trip-number = 3 [
      if step = 0 [unlinked-trip "home" 0 0 0 0 0 0 0 0]
      if step = 1 [unlinked-trip "bicycle" v-bicycle sta-a-xcor sta-a-ycor 0 1 0 0 0]
      if step = 2 [unlinked-trip "train" v-train sta-b-xcor sta-b-ycor 1 0 0 0 0]
      if step = 3 [
        ifelse bicycle-promotion = "no" [
          unlinked-trip "walk" v-walk destination-xcor destination-ycor 0 0 0 0 0
        ][
          unlinked-trip "bicycle" v-bicycle destination-xcor destination-ycor 0 0 0 0 0
        ]
      ]
      if step = 4 [unlinked-trip "office-a" 0 0 0 0 0 0 0 1]
      if step = 5 [unlinked-trip "office-d" 0 0 0 0 0 0 0 1]
      if step = 6 [
        ifelse bicycle-promotion = "no" [
          unlinked-trip "walk" v-walk facility-xcor facility-ycor 0 0 0 3 1
        ][
          unlinked-trip "bicycle" v-bicycle facility-xcor facility-ycor 0 0 0 3 1
        ]
      ]
      if step = 7 [unlinked-trip "facility-a" 0 0 0 0 0 0 0 1]
      if step = 8 [unlinked-trip "facility-d" 0 0 0 0 0 0 0 1]
      if step = 9 [
        ifelse bicycle-promotion = "no" [
          unlinked-trip "walk" v-walk sta-b-xcor sta-b-ycor 0 0 0 3 2
        ][
          unlinked-trip "bicycle" v-bicycle sta-b-xcor sta-b-ycor 0 0 0 3 2
        ]
      ]
      if step = 10 [unlinked-trip "train" v-train sta-a-xcor sta-a-ycor 1 0 0 0 2]
      if step = 11 [unlinked-trip "bicycle" v-bicycle house-xcor house-ycor 0 0 0 0 3]
    ]

    if linked-trip-number = 4 [
      if park&walk = "no" [
        if step = 0 [unlinked-trip "home" 0 0 0 0 0 0 0 0]
        if step = 1 [unlinked-trip "car" v-car destination-xcor destination-ycor 0 0 0 3 0]
        if step = 2 [unlinked-trip "office-a" 0 0 0 0 0 0 0 1]
        if step = 3 [unlinked-trip "office-d" 0 0 0 0 0 0 0 1]
        if step = 4 [unlinked-trip "car" v-car facility-xcor facility-ycor 0 0 0 1 1]
        if step = 5 [unlinked-trip "facility-a" 0 0 0 0 0 0 0 1]
        if step = 6 [unlinked-trip "facility-d" 0 0 0 0 0 0 0 1]
        if step = 7 [unlinked-trip "car" v-car house-xcor house-ycor 0 0 0 1 3]
        let dist-car-4-0-f ((destination-xcor - house-xcor) ^ 2 + (destination-ycor - house-ycor) ^ 2) ^ 0.5
        let dist-car-4-2-f ((facility-xcor - destination-xcor) ^ 2 + (facility-ycor - destination-ycor) ^ 2) ^ 0.5
        let dist-car-4-3-f ((house-xcor - facility-xcor) ^ 2 + (house-ycor - facility-ycor) ^ 2) ^ 0.5
        set dist-car dist-car-4-0-f + dist-car-4-2-f + dist-car-4-3-f
      ]
      if park&walk = "yes" [
      let closest min-one-of parkings [distancexy [destination-xcor] of myself [destination-ycor] of myself]
      set my-parking-xcor [xcor] of closest
      set my-parking-ycor [ycor] of closest
        ifelse ((facility-xcor - sta-b-xcor) ^ 2 + (facility-ycor - sta-b-ycor) ^ 2) ^ 0.5 < p-radius [
          if step = 0 [unlinked-trip "home" 0 0 0 0 0 0 0 0]
          if step = 1 [unlinked-trip "car" v-car my-parking-xcor my-parking-ycor 0 0 1 1 0]
          if step = 2 [unlinked-trip "walk" v-walk destination-xcor destination-ycor 0 0 0 0 0]
          if step = 3 [unlinked-trip "office-a" 0 0 0 0 0 0 0 1]
          if step = 4 [unlinked-trip "office-d" 0 0 0 0 0 0 0 1]
          if step = 5 [unlinked-trip "walk" v-walk facility-xcor facility-ycor 0 0 0 3 1]
          if step = 6 [unlinked-trip "facility-a" 0 0 0 0 0 0 0 1]
          if step = 7 [unlinked-trip "facility-d" 0 0 0 0 0 0 0 1]
          if step = 8 [unlinked-trip "walk" v-walk my-parking-xcor my-parking-ycor 0 0 0 3 2]
          if step = 9 [unlinked-trip "car" v-car house-xcor house-ycor 0 0 0 1 3]
          let dist-car-4-0-f ((my-parking-xcor - house-xcor) ^ 2 + (my-parking-ycor - house-ycor) ^ 2) ^ 0.5
          let dist-car-4-5-f ((house-xcor - my-parking-xcor) ^ 2 + (house-ycor - my-parking-ycor) ^ 2) ^ 0.5
          set dist-car dist-car-4-0-f + dist-car-4-5-f
        ][
          if step = 0 [unlinked-trip "home" 0 0 0 0 0 0 0 0]
          if step = 1 [unlinked-trip "car" v-car my-parking-xcor my-parking-ycor 0 0 0 3 0]
          if step = 2 [unlinked-trip "walk" v-walk destination-xcor destination-ycor 0 0 0 3 0]
          if step = 3 [unlinked-trip "office-a" 0 0 0 0 0 0 0 1]
          if step = 4 [unlinked-trip "office-d" 0 0 0 0 0 0 0 1]
          if step = 5 [unlinked-trip "walk" v-walk my-parking-xcor my-parking-ycor 0 0 0 0 1]
          if step = 6 [unlinked-trip "car" v-car facility-xcor facility-ycor 0 0 0 1 1]
          if step = 7 [unlinked-trip "facility-a" 0 0 0 0 0 0 0 1]
          if step = 8 [unlinked-trip "facility-d" 0 0 0 0 0 0 0 1]
          if step = 9 [unlinked-trip "car" v-car house-xcor house-ycor 0 0 0 1 3]
          let dist-car-4-0-f ((my-parking-xcor - house-xcor) ^ 2 + (my-parking-ycor - house-ycor) ^ 2) ^ 0.5
          let dist-car-4-4-f ((facility-xcor - my-parking-xcor) ^ 2 + (facility-ycor - my-parking-ycor) ^ 2) ^ 0.5
          let dist-car-4-5-f ((house-xcor - facility-xcor) ^ 2 + (house-ycor - facility-ycor) ^ 2) ^ 0.5
          set dist-car dist-car-4-0-f + dist-car-4-4-f + dist-car-4-5-f
        ]
      ]
    ]

    if linked-trip-number = 5 [
      if park&walk = "no" [
        if step = 0 [unlinked-trip "home" 0 0 0 0 0 0 0 0]
        if step = 1 [unlinked-trip "car" v-car house-xcor hw-ycor 0 0 0 1 0]
        if step = 2 [unlinked-trip "car-hw" v-car-hwghway my-parking-xcor hw-ycor 0 0 0 2 0]
        if step = 3 [unlinked-trip "car" v-car destination-xcor destination-ycor 0 0 1 1 0]
        if step = 4 [unlinked-trip "office-a" 0 0 0 0 0 0 0 1]
        if step = 5 [unlinked-trip "office-d" 0 0 0 0 0 0 0 1]
        if step = 6 [unlinked-trip "car" v-car facility-xcor facility-ycor 0 0 0 1 1]
        if step = 7 [unlinked-trip "facility-a" 0 0 0 0 0 0 0 1]
        if step = 8 [unlinked-trip "facility-d" 0 0 0 0 0 0 0 1]
        if step = 9 [unlinked-trip "car" v-car facility-xcor hw-ycor 0 0 0 1 2]
        if step = 10 [unlinked-trip "car-hw" v-car-hwghway house-xcor hw-ycor 0 0 0 2 2]
        if step = 11 [unlinked-trip "car" v-car house-xcor house-ycor 0 0 0 1 3]
        let dist-car-5-0-f ((house-xcor - house-xcor) ^ 2 + (hw-ycor - house-ycor) ^ 2) ^ 0.5
        let dist-car-5-1-f ((destination-xcor - house-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
        let dist-car-5-2-f ((destination-xcor - destination-xcor) ^ 2 + (destination-ycor - hw-ycor) ^ 2) ^ 0.5
        let dist-car-5-4-f ((facility-xcor - destination-xcor) ^ 2 + (facility-ycor - destination-ycor) ^ 2) ^ 0.5
        let dist-car-5-5-f ((facility-xcor - facility-xcor) ^ 2 + (hw-ycor - facility-ycor) ^ 2) ^ 0.5
        let dist-car-5-6-f ((house-xcor - facility-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
        let dist-car-5-7-f ((house-xcor - house-xcor) ^ 2 + (house-ycor - hw-ycor) ^ 2) ^ 0.5
        set dist-car dist-car-5-0-f + dist-car-5-1-f + dist-car-5-2-f + dist-car-5-4-f + dist-car-5-5-f + dist-car-5-6-f + dist-car-5-7-f
      ]
      if park&walk = "yes" [
        let closest min-one-of parkings [distancexy [destination-xcor] of myself [destination-ycor] of myself]
        set my-parking-xcor [xcor] of closest
        set my-parking-ycor [ycor] of closest
        ifelse  ((facility-xcor - sta-b-xcor) ^ 2 + (facility-ycor - sta-b-ycor) ^ 2) ^ 0.5 < p-radius [
          if step = 0 [unlinked-trip "home" 0 0 0 0 0 0 0 0]
          if step = 1 [unlinked-trip "car" v-car house-xcor hw-ycor 0 0 0 1 0]
          if step = 2 [unlinked-trip "car-hw" v-car-hwghway my-parking-xcor hw-ycor 0 0 0 2 0]
          if step = 3 [unlinked-trip "car" v-car my-parking-xcor my-parking-ycor 0 0 1 1 0]
          if step = 4 [unlinked-trip "walk" v-walk destination-xcor destination-ycor 0 0 0 0 0]
          if step = 5 [unlinked-trip "office-a" 0 0 0 0 0 0 0 1]
          if step = 6 [unlinked-trip "office-d" 0 0 0 0 0 0 0 1]
          if step = 7 [unlinked-trip "walk" v-walk facility-xcor facility-ycor 0 0 0 3 1]
          if step = 8 [unlinked-trip "facility-a" 0 0 0 0 0 0 0 1]
          if step = 9 [unlinked-trip "facility-d" 0 0 0 0 0 0 0 1]
          if step = 10 [unlinked-trip "walk" v-walk my-parking-xcor my-parking-ycor 0 0 0 3 2]
          if step = 11 [unlinked-trip "car" v-car my-parking-xcor hw-ycor 0 0 0 1 2]
          if step = 12 [unlinked-trip "car-hw" v-car-hwghway house-xcor hw-ycor 0 0 0 2 2]
          if step = 13 [unlinked-trip "car" v-car house-xcor house-ycor 0 0 0 1 3]
          let dist-car-5-0-f ((house-xcor - house-xcor) ^ 2 + (hw-ycor - house-ycor) ^ 2) ^ 0.5
          let dist-car-5-1-f ((my-parking-xcor - house-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
          let dist-car-5-2-f ((my-parking-xcor - my-parking-xcor) ^ 2 + (my-parking-ycor - hw-ycor) ^ 2) ^ 0.5
          let dist-car-5-7-f ((my-parking-xcor - my-parking-xcor) ^ 2 + (hw-ycor - my-parking-ycor) ^ 2) ^ 0.5
          let dist-car-5-8-f ((house-xcor - my-parking-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
          let dist-car-5-9-f ((house-xcor - house-xcor) ^ 2 + (house-ycor - hw-ycor) ^ 2) ^ 0.5
          set dist-car dist-car-5-0-f + dist-car-5-1-f + dist-car-5-2-f + dist-car-5-7-f + dist-car-5-8-f + dist-car-5-9-f
        ][
          if step = 0 [unlinked-trip "home" 0 0 0 0 0 0 0 0]
          if step = 1 [unlinked-trip "car" v-car house-xcor hw-ycor 0 0 0 1 0]
          if step = 2 [unlinked-trip "car-hw" v-car-hwghway my-parking-xcor hw-ycor 0 0 0 2 0]
          if step = 3 [unlinked-trip "car" v-car my-parking-xcor my-parking-ycor 0 0 1 1 0]
          if step = 4 [unlinked-trip "walk" v-walk destination-xcor destination-ycor 0 0 0 0 0]
          if step = 5 [unlinked-trip "office-a" 0 0 0 0 0 0 0 1]
          if step = 6 [unlinked-trip "office-d" 0 0 0 0 0 0 0 1]
          if step = 7 [unlinked-trip "walk" v-walk my-parking-xcor my-parking-ycor 0 0 0 0 1]
          if step = 8 [unlinked-trip "car" v-car facility-xcor facility-ycor 0 0 0 1 1]
          if step = 9 [unlinked-trip "facility-a" 0 0 0 0 0 0 0 1]
          if step = 10 [unlinked-trip "facility-d" 0 0 0 0 0 0 0 1]
          if step = 11 [unlinked-trip "car" v-car facility-xcor hw-ycor 0 0 0 1 2]
          if step = 12 [unlinked-trip "car-hw" v-car-hwghway house-xcor hw-ycor 0 0 0 2 2]
          if step = 13 [unlinked-trip "car" v-car house-xcor house-ycor 0 0 0 1 3]
          let dist-car-5-0-f ((house-xcor - house-xcor) ^ 2 + (hw-ycor - house-ycor) ^ 2) ^ 0.5
          let dist-car-5-1-f ((my-parking-xcor - house-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
          let dist-car-5-2-f ((my-parking-xcor - my-parking-xcor) ^ 2 + (my-parking-ycor - hw-ycor) ^ 2) ^ 0.5
          let dist-car-5-6-f ((facility-xcor - my-parking-xcor) ^ 2 + (facility-ycor - my-parking-ycor) ^ 2) ^ 0.5
          let dist-car-5-7-f ((facility-xcor - facility-xcor) ^ 2 + (hw-ycor - facility-ycor) ^ 2) ^ 0.5
          let dist-car-5-8-f ((house-xcor - facility-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
          let dist-car-5-9-f ((house-xcor - house-xcor) ^ 2 + (house-ycor - hw-ycor) ^ 2) ^ 0.5
          set dist-car dist-car-5-0-f + dist-car-5-1-f + dist-car-5-2-f + dist-car-5-6-f + dist-car-5-7-f + dist-car-5-8-f + dist-car-5-9-f
        ]
      ]
    ]

    if (linked-trip-number = 6 or linked-trip-number = 7) [

    ]

    if (linked-trip-number = 8 or linked-trip-number = 9) [

    ]
  ]

  if step = "last" [
    if arrival-at-destination != 1 [
      set c-time eta-t * t-total
      set c-money bicycleparking-flag * c-bicycleparking + parking-flag * c-parking + train-flag * c-train-fare * 2 + fuel-cost * c-fuel * dist-car
      set c-fatigue f-walk * t-walk + f-bicycle * t-bicycle + f-train * t-train + f-car * t-car + f-congestion + f-tram * t-tram
      set cost c-money + c-time + c-fatigue - bustle-degree

      ifelse house-search = "no-house-search" [
        let v alpha * -1 * cost + (1 - alpha) * (item linked-trip-number vlist)
        set vlist replace-item linked-trip-number vlist v
      ][
        let den-h 0
        let den-d 0
        ask patch house-xcor house-ycor [
          set den-h (count patches with [pcolor = green] in-radius (area * 1))
          set den-d (count patches with [pcolor = blue] in-radius (area * 1))
        ]
        set house-prediction-cost (cost * 1) + (eta-r * (den-h + rate-d * den-d) * size-of-home / (((area * 1) ^ 2) * pi)) * (10000 / n-people)
      ]
    ]
    set arrival-at-destination 1
  ]

end

to unlinked-trip [t-type velocity dest-xcor dest-ycor train-check bicycleparking-check parking-check congestion-check arrival-flag]
  set my-t-type t-type
  set my-arrival-flag arrival-flag
  set my-dest-xcor dest-xcor
  set my-dest-ycor dest-ycor

  ifelse t-type = "home" [
    set departure-from-home-check 1
    home-departure
  ][
  ifelse t-type = "office-a" [
    set arrival-at-office-check 1
    if my-commuting-time-count-check = 0 [
      set my-commuting-time (ticks - my-home-departure-time)
      set my-commuting-time-count-check 1
    ]
    office-arrival
  ][
  ifelse t-type = "office-d" [
    set departure-from-office-check 1
    office-departure
  ][
  ifelse t-type = "facility-a" [
    set arrival-at-facility-check 1
    facility-arrival
  ][
  ifelse t-type = "facility-d" [
    set departure-from-facility-check 1
    facility-departure
  ][
  ifelse t-type = "skip" [
    set skip-check 1
    skip
  ][
    facexy dest-xcor dest-ycor
    if congestion-check = 0 [
      set my-velocity velocity
      forward my-velocity
    ]
    if congestion-check = 1 [
      congestion velocity
    ]
    if congestion-check = 2 [
      congestion-hi velocity
    ]
    if congestion-check = 3 [
      bustle velocity
    ]

    if (distancexy dest-xcor dest-ycor <= my-velocity) [
      set xcor dest-xcor
      set ycor dest-ycor
      set start-time-list replace-item (step + 1) start-time-list ticks

      if t-type = "walk" [
        set t-walk t-walk + (item (step + 1) start-time-list) - (item step start-time-list)
      ]
      if t-type = "bicycle" [
        set t-bicycle t-bicycle + (item (step + 1) start-time-list) - (item step start-time-list)
      ]
      if t-type = "train" [
        set t-train t-train + (item (step + 1) start-time-list) - (item step start-time-list)
      ]
      if t-type = "car" [
        set t-car t-car + (item (step + 1) start-time-list) - (item step start-time-list)
      ]
      if t-type = "tram" [

      ]
      set t-total t-walk + t-bicycle + t-train + t-car + t-tram

      if train-check = 1 [
        set train-flag 1
      ]
      if bicycleparking-check = 1 [
        set bicycleparking-flag 1
      ]
      if parking-check = 1 [
        set parking-flag 1
      ]
      set step step + 1

      if arrival-flag = 3 [
        set step "last"
      ]
    ]
  ]
  ]
  ]
  ]
  ]
  ]
end

to home-departure
  ask people with [(departure-from-home-check = 1) and (my-home-departure-time <= ticks)] [
    set departure-from-home-check 0
    set start-time-list replace-item (step + 1) start-time-list ticks
    set step step + 1
  ]
end

to office-arrival
  if count people with [arrival-at-office-check = 1] >= n-people [
    ask people[
      set arrival-at-office-check 0
      set start-time-list replace-item (step + 1) start-time-list ticks
      set my-office-departure-time (ticks + my-office-delay)
      set step step + 1
    ]
  ]
end


to office-departure
  ask people with [(departure-from-office-check = 1) and (my-office-departure-time <= ticks)] [
    set departure-from-office-check 0
    set start-time-list replace-item (step + 1) start-time-list ticks
    set step step + 1
  ]
end


to facility-arrival
  ask people with [arrival-at-facility-check = 1] [
    set arrival-at-facility-check 0
    set start-time-list replace-item (step + 1) start-time-list ticks
    set my-facility-departure-time (ticks + my-facility-delay)
    set step step + 1
  ]
end


to facility-departure
  ask people with [(departure-from-facility-check = 1) and (my-facility-departure-time <= ticks)] [
    set departure-from-facility-check 0
    set start-time-list replace-item (step + 1) start-time-list ticks
    set step step + 1
  ]
end


to skip
  ask people with [skip-check = 1] [
    set skip-check 0
    set start-time-list replace-item (step + 1) start-time-list ticks
    set step step + 1
  ]
end

to congestion [velocity]
  let density (count people with [my-t-type = "car"] in-radius (area * 1.5) - 1)
  ifelse density >= d0 [
    let velocity-cong max (list (velocity * (1 - density * 0.1)) (velocity * (1 / 3)))
    set my-velocity velocity-cong
    ifelse park&walk = "yes" [
      ifelse distancexy sta-b-xcor sta-b-ycor <= (p-radius + 1) [
        ifelse my-arrival-flag = 0 [
          facexy sta-b-xcor sta-b-ycor
          let s (sta-b-xcor - xcor) * (my-dest-ycor - ycor) - (sta-b-ycor - ycor) * (my-dest-xcor - xcor)
          ifelse s <= 0 [
            right 90
            forward my-velocity
            let f-cong-per-min min (list (f-car * density * 0.1) (f-car * 1))
            set f-congestion f-congestion + f-cong-per-min
          ][
            left 90
            forward my-velocity
            let f-cong-per-min min (list (f-car * density * 0.1) (f-car * 1))
            set f-congestion f-congestion + f-cong-per-min
          ]
        ][
          facexy sta-b-xcor sta-b-ycor
          let s (sta-b-xcor - xcor) * (my-dest-ycor - ycor) - (sta-b-ycor - ycor) * (my-dest-xcor - xcor)
          ifelse s <= 0 [
            right 90
            forward my-velocity
            let f-cong-per-min min (list (f-car * density * 0.1) (f-car * 1))
            set f-congestion f-congestion + f-cong-per-min
          ][
            left 90
            forward my-velocity
            let f-cong-per-min min (list (f-car * density * 0.1) (f-car * 1))
            set f-congestion f-congestion + f-cong-per-min
          ]
        ]
      ][
        forward my-velocity
        let f-cong-per-min min (list (f-car * density * 0.1) (f-car * 1))
        set f-congestion f-congestion + f-cong-per-min
      ]
    ][
      forward my-velocity
      let f-cong-per-min min (list (f-car * density * 0.1) (f-car * 1))
      set f-congestion f-congestion + f-cong-per-min
    ]
  ][
    set my-velocity velocity
    ifelse park&walk = "yes" [
      ifelse distancexy sta-b-xcor sta-b-ycor <= (p-radius + 1) [
        ifelse my-arrival-flag = 0 [
          facexy sta-b-xcor sta-b-ycor
          let s (sta-b-xcor - xcor) * (my-dest-ycor - ycor) - (sta-b-ycor - ycor) * (my-dest-xcor - xcor)
          ifelse s <= 0 [
            right 90
            forward my-velocity
          ][
            left 90
            forward my-velocity
          ]
        ][
          facexy sta-b-xcor sta-b-ycor
          let s (sta-b-xcor - xcor) * (my-dest-ycor - ycor) - (sta-b-ycor - ycor) * (my-dest-xcor - xcor)
          ifelse s <= 0 [
            right 90
            forward my-velocity
          ][
            left 90
            forward my-velocity
          ]
        ]
      ][
        forward my-velocity
      ]
    ][
      forward my-velocity
    ]
  ]
end


to congestion-hi [velocity]
  let density (count people with [my-t-type = "car-hw"] in-radius (area * 1.5) - 1)
  ifelse density >= d0
  [
    let velocity-cong max (list (velocity * (1 - density * 0.1)) (velocity * (1 / 3)))
    set my-velocity velocity-cong
    forward my-velocity
    let f-cong-per-min min (list (f-car * density * 0.1) (f-car * 1))
    set f-congestion f-congestion + f-cong-per-min
  ][
    set my-velocity velocity
    forward my-velocity
  ]
end


to bustle [velocity]
  set my-velocity velocity
  forward my-velocity
  if distancexy facility-xcor facility-ycor <= bst-impact-dist [
    let density-walk count people with [my-t-type = "walk" and ( distancexy facility-xcor facility-ycor <= bst-impact-dist ) ] in-radius (area * 1)
    let density-bicycle count people with [my-t-type = "bicycle" and ( distancexy facility-xcor facility-ycor <= bst-impact-dist ) ] in-radius (area * 1)
    let density density-walk + density-bicycle - 1
    let bst-dgr-per-min min (list (density * coeff-attraction) (coeff-attraction * 100))
    set bustle-degree bustle-degree + bst-dgr-per-min
  ]
end


to arrival-check [house-search]
   if count people with [arrival-at-destination = 1] >= n-people [
     e-greedy
     set days days + 1
     ask people [
       trip-setup
       set epsilon gamma * epsilon
     ]
  ]
end

to trip-setup
   setxy house-xcor house-ycor
   set train-flag 0
   set bicycleparking-flag 0
   set parking-flag 0
   set arrival-at-destination 0
   set step 0
   set start-time-list n-values 30 [0]
   set start-time-list replace-item 0 start-time-list ticks
   set t-walk 0
   set t-bicycle 0
   set t-car 0
   set t-train 0
   set t-tram 0
   set dist-car 0
   set f-congestion 0
   set my-arrival-flag 0
   set bustle-degree 0

   set my-commuting-time-count-check 0
   set max-commuting-time max [my-commuting-time] of people

   set my-home-delay max-commuting-time - my-commuting-time + min (list (abs (round (random-normal 12 3))) 20)
   set my-home-departure-time (item 0 start-time-list) + my-home-delay

   set my-office-delay min (list (abs (round (random-normal 12 3))) 20)
   set my-facility-delay 0
end


to e-greedy
  ask people [
    ifelse epsilon > random-float 1 [
      ifelse tram = "yes" [

      ][
        set linked-trip-number random 6
      ]
      if park&walk = "yes" [
        if ((sta-b-xcor - house-xcor) ^ 2 + (sta-b-ycor - house-ycor) ^ 2) ^ 0.5 <= p-radius [
          if (linked-trip-number = 4 or linked-trip-number = 5) [
            if tram = "no" [
              set linked-trip-number random 4
            ]
            if tram = "yes" [

            ]
          ]
        ]
      ]
    ][
      set linked-trip-number position max(vlist) vlist
      if park&walk = "yes" [
        if ((sta-b-xcor - house-xcor) ^ 2 + (sta-b-ycor - house-ycor) ^ 2) ^ 0.5 <= p-radius [
          if (linked-trip-number = 4 or linked-trip-number = 5) [
            if tram = "no" [
              set linked-trip-number random 4
            ]
            if tram = "yes" [

            ]
          ]
        ]
      ]
    ]
  ]
end


to habitation-selection
  if days >= day-learn[
    if habitation-selection-flag = 0 [
      ask people [
        set moving-candidate 0
      ]

      set center-of-house-xcor mean [house-xcor] of people
      set center-of-house-ycor mean [house-ycor] of people
      set sd-of-house-xcor standard-deviation [house-xcor] of people
      set sd-of-house-ycor standard-deviation [house-ycor] of people
      set candidate-i 0

      ask n-of int(n-people * (1 / 10)) people[
        set moving-candidate 1
        set house-prediction-cost-list n-values n-candidate [99999999]
        set house-candidate-xcor n-values n-candidate [0]
        set house-candidate-ycor n-values n-candidate [0]
        set temp-t-total-list n-values n-candidate [0]
        set color pink

        ask patch house-xcor house-ycor [set pcolor black]
        let i 0
        while [i < n-candidate][
          ask patch destination-xcor destination-ycor [set pcolor blue]
          let temporary-house-xcor limited-random-xcor center-of-house-xcor (coeff-for-sd-of-h * sd-of-house-xcor)
          let temporary-house-ycor limited-random-ycor center-of-house-ycor (coeff-for-sd-of-h * sd-of-house-xcor)
          let temporary-num-h-and-d 9999
          ask patch temporary-house-xcor temporary-house-ycor [
            let num-h count patches with [pcolor = green] in-radius sprawl-limit
            let num-d count patches with [pcolor = blue] in-radius sprawl-limit
            let num-sta-and-f count patches with [pcolor = red] in-radius sprawl-limit
            let num-tram-sta count tram-stas in-radius sprawl-limit
            set temporary-num-h-and-d (num-h + num-d + num-sta-and-f + num-tram-sta)
          ]
          let distance-between-candidatedate-and-sta-b (((sta-b-xcor - temporary-house-xcor) ^ 2 + (sta-b-ycor - temporary-house-ycor) ^ 2) ^ 0.5)
          set house-candidate-xcor replace-item i house-candidate-xcor temporary-house-xcor
          set house-candidate-ycor replace-item i house-candidate-ycor temporary-house-ycor
          ifelse ((temporary-num-h-and-d < 2) or ((park&walk = "yes") and (linked-trip-number = 4 or linked-trip-number = 5) and (distance-between-candidatedate-and-sta-b <= p-radius))) [
            set i i
          ][
            set i i + 1
          ]
        ]
      ]

      ask people with [moving-candidate = 1][
        set house-xcor (item candidate-i house-candidate-xcor)
        set house-ycor (item candidate-i house-candidate-ycor)
        setxy house-xcor house-ycor
      ]
      set habitation-selection-flag 1
    ]

    ask people[
      linked-trip "house-search"
    ]

    if count people with [arrival-at-destination = 1] >= n-people [
      ask people [
        trip-setup
      ]
      ask people[
        set final-t-total t-total
      ]
      ask people with [moving-candidate = 1][
        set house-prediction-cost-list replace-item candidate-i house-prediction-cost-list house-prediction-cost
        set temp-t-total-list replace-item candidate-i temp-t-total-list t-total
      ]

      set candidate-i candidate-i + 1
        ifelse candidate-i < n-candidate [
          ask people with [moving-candidate = 1][
            set house-xcor (item candidate-i house-candidate-xcor)
            set house-ycor (item candidate-i house-candidate-ycor)
            setxy house-xcor house-ycor
          ]
        ][
        ask people with [moving-candidate = 1][
          set min-prediction-cost-number position min(house-prediction-cost-list) house-prediction-cost-list
          set house-xcor (item min-prediction-cost-number house-candidate-xcor)
          set house-ycor (item min-prediction-cost-number house-candidate-ycor)
          set house-prediction-cost 0
          ask patch house-xcor house-ycor [set pcolor green]
          ask patch destination-xcor destination-ycor [set pcolor blue]
          set color white
          set final-t-total (item min-prediction-cost-number temp-t-total-list)
          set epsilon initial-epsilon
        ]
        show (word "residence selection " (count-of-moving + 1) " of " n-relocation)

        set list-of-ltn0 replace-item count-of-moving list-of-ltn0 count people with [linked-trip-number = 0]
        set list-of-ltn1 replace-item count-of-moving list-of-ltn1 count people with [linked-trip-number = 1]
        set list-of-ltn2 replace-item count-of-moving list-of-ltn2 count people with [linked-trip-number = 2]
        set list-of-ltn3 replace-item count-of-moving list-of-ltn3 count people with [linked-trip-number = 3]
        set list-of-ltn4 replace-item count-of-moving list-of-ltn4 count people with [linked-trip-number = 4]
        set list-of-ltn5 replace-item count-of-moving list-of-ltn5 count people with [linked-trip-number = 5]
        set list-of-ltn6 replace-item count-of-moving list-of-ltn6 count people with [linked-trip-number = 6]
        set list-of-ltn7 replace-item count-of-moving list-of-ltn7 count people with [linked-trip-number = 7]
        set list-of-ltn8 replace-item count-of-moving list-of-ltn8 count people with [linked-trip-number = 8]
        set list-of-ltn9 replace-item count-of-moving list-of-ltn9 count people with [linked-trip-number = 9]

        set list-of-t-total replace-item count-of-moving list-of-t-total ((sum [final-t-total] of people) / n-people)

        set center-of-house-xcor mean [house-xcor] of people
        set center-of-house-ycor mean [house-ycor] of people
        set list-of-center-xcor replace-item count-of-moving list-of-center-xcor (precision center-of-house-xcor 3)
        set list-of-center-ycor replace-item count-of-moving list-of-center-ycor (precision center-of-house-ycor 3)

        set sd-of-house-xcor standard-deviation [house-xcor] of people
        set sd-of-house-ycor standard-deviation [house-ycor] of people
        set list-of-sd-xcor replace-item count-of-moving list-of-sd-xcor (precision sd-of-house-xcor 3)
        set list-of-sd-ycor replace-item count-of-moving list-of-sd-ycor (precision sd-of-house-ycor 3)

        ask n-of int(n-people * (4 / 9)) people with [moving-candidate = 0][
          set epsilon initial-epsilon
        ]

        ask people[
          if OFS-location = "A: no" [
            ifelse (linked-trip-number = 4 or linked-trip-number = 5)[
              if park&walk = "no" [
                if linked-trip-number = 4[
                  let dist-car-4-0 ((destination-xcor - house-xcor) ^ 2 + (destination-ycor - house-ycor) ^ 2) ^ 0.5
                  let dist-car-4-2 ((house-xcor - destination-xcor) ^ 2 + (house-ycor - destination-ycor) ^ 2) ^ 0.5
                  set my-car-moving dist-car-4-0 + dist-car-4-2
                ]
                if linked-trip-number = 5[
                  let dist-car-5-0 ((house-xcor - house-xcor) ^ 2 + (hw-ycor - house-ycor) ^ 2) ^ 0.5
                  let dist-car-5-1 ((destination-xcor - house-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
                  let dist-car-5-2 ((destination-xcor - destination-xcor) ^ 2 + (destination-ycor - hw-ycor) ^ 2) ^ 0.5
                  let dist-car-5-4 ((destination-xcor - destination-xcor) ^ 2 + (hw-ycor - destination-ycor) ^ 2) ^ 0.5
                  let dist-car-5-5 ((house-xcor - destination-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
                  let dist-car-5-6 ((house-xcor - house-xcor) ^ 2 + (house-ycor - hw-ycor) ^ 2) ^ 0.5
                  set my-car-moving dist-car-5-0 + dist-car-5-1 + dist-car-5-2 + dist-car-5-4 + dist-car-5-5 + dist-car-5-6
                ]
              ]
              if park&walk = "yes" [
                if linked-trip-number = 4[
                  let dist-car-4-0 ((my-parking-xcor - house-xcor) ^ 2 + (my-parking-ycor - house-ycor) ^ 2) ^ 0.5
                  let dist-car-4-4 ((house-xcor - my-parking-xcor) ^ 2 + (house-ycor - my-parking-ycor) ^ 2) ^ 0.5
                  set my-car-moving dist-car-4-0 + dist-car-4-4
                ]
                if linked-trip-number = 5[
                  let dist-car-5-0 ((house-xcor - house-xcor) ^ 2 + (hw-ycor - house-ycor) ^ 2) ^ 0.5
                  let dist-car-5-1 ((my-parking-xcor - house-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
                  let dist-car-5-2 ((my-parking-xcor - my-parking-xcor) ^ 2 + (my-parking-ycor - hw-ycor) ^ 2) ^ 0.5
                  let dist-car-5-6 ((my-parking-xcor - my-parking-xcor) ^ 2 + (hw-ycor - my-parking-ycor) ^ 2) ^ 0.5
                  let dist-car-5-7 ((house-xcor - my-parking-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
                  let dist-car-5-8 ((house-xcor - house-xcor) ^ 2 + (house-ycor - hw-ycor) ^ 2) ^ 0.5
                  set my-car-moving dist-car-5-0 + dist-car-5-1 + dist-car-5-2 + dist-car-5-6 + dist-car-5-7 + dist-car-5-8
                ]
              ]
            ][
              set my-car-moving 0
            ]
          ]

          if OFS-location != "A: no" [
            ifelse (linked-trip-number = 4 or linked-trip-number = 5)[
              if park&walk = "no" [
                if linked-trip-number = 4[
                  let dist-car-4-0-f ((destination-xcor - house-xcor) ^ 2 + (destination-ycor - house-ycor) ^ 2) ^ 0.5
                  let dist-car-4-2-f ((facility-xcor - destination-xcor) ^ 2 + (facility-ycor - destination-ycor) ^ 2) ^ 0.5
                  let dist-car-4-3-f ((house-xcor - facility-xcor) ^ 2 + (house-ycor - facility-ycor) ^ 2) ^ 0.5
                  set my-car-moving dist-car-4-0-f + dist-car-4-2-f + dist-car-4-3-f
                ]
                if linked-trip-number = 5[
                  let dist-car-5-0-f ((house-xcor - house-xcor) ^ 2 + (hw-ycor - house-ycor) ^ 2) ^ 0.5
                  let dist-car-5-1-f ((destination-xcor - house-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
                  let dist-car-5-2-f ((destination-xcor - my-parking-xcor) ^ 2 + (destination-ycor - hw-ycor) ^ 2) ^ 0.5
                  let dist-car-5-4-f ((facility-xcor - destination-xcor) ^ 2 + (facility-ycor - destination-ycor) ^ 2) ^ 0.5
                  let dist-car-5-5-f ((facility-xcor - facility-xcor) ^ 2 + (hw-ycor - facility-ycor) ^ 2) ^ 0.5
                  let dist-car-5-6-f ((house-xcor - facility-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
                  let dist-car-5-7-f ((house-xcor - house-xcor) ^ 2 + (house-ycor - hw-ycor) ^ 2) ^ 0.5
                  set my-car-moving dist-car-5-0-f + dist-car-5-1-f + dist-car-5-2-f + dist-car-5-4-f + dist-car-5-5-f + dist-car-5-6-f + dist-car-5-7-f
                ]
              ]
              if park&walk = "yes" [
                if linked-trip-number = 4[
                  ifelse ((facility-xcor - sta-b-xcor) ^ 2 + (facility-ycor - sta-b-ycor) ^ 2) ^ 0.5 < p-radius[
                    let dist-car-4-0-f ((my-parking-xcor - house-xcor) ^ 2 + (my-parking-ycor - house-ycor) ^ 2) ^ 0.5
                    let dist-car-4-5-f ((house-xcor - my-parking-xcor) ^ 2 + (house-ycor - my-parking-ycor) ^ 2) ^ 0.5
                    set my-car-moving dist-car-4-0-f + dist-car-4-5-f
                  ][
                    let dist-car-4-0-f ((my-parking-xcor - house-xcor) ^ 2 + (my-parking-ycor - house-ycor) ^ 2) ^ 0.5
                    let dist-car-4-4-f ((facility-xcor - my-parking-xcor) ^ 2 + (facility-ycor - my-parking-ycor) ^ 2) ^ 0.5
                    let dist-car-4-5-f ((house-xcor - facility-xcor) ^ 2 + (house-ycor - facility-ycor) ^ 2) ^ 0.5
                    set my-car-moving dist-car-4-0-f + dist-car-4-4-f + dist-car-4-5-f
                  ]
                ]
                if linked-trip-number = 5[
                  ifelse ((facility-xcor - sta-b-xcor) ^ 2 + (facility-ycor - sta-b-ycor) ^ 2) ^ 0.5 < p-radius[
                    let dist-car-5-0-f ((house-xcor - house-xcor) ^ 2 + (hw-ycor - house-ycor) ^ 2) ^ 0.5
                    let dist-car-5-1-f ((destination-xcor - house-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
                    let dist-car-5-2-f ((destination-xcor - my-parking-xcor) ^ 2 + (destination-ycor - hw-ycor) ^ 2) ^ 0.5
                    let dist-car-5-7-f ((destination-xcor - my-parking-xcor) ^ 2 + (hw-ycor - destination-ycor) ^ 2) ^ 0.5
                    let dist-car-5-8-f ((house-xcor - destination-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
                    let dist-car-5-9-f ((house-xcor - house-xcor) ^ 2 + (house-ycor - hw-ycor) ^ 2) ^ 0.5
                    set my-car-moving dist-car-5-0-f + dist-car-5-1-f + dist-car-5-2-f + dist-car-5-7-f + dist-car-5-8-f + dist-car-5-9-f
                  ][
                    let dist-car-5-0-f ((house-xcor - house-xcor) ^ 2 + (hw-ycor - house-ycor) ^ 2) ^ 0.5
                    let dist-car-5-1-f ((destination-xcor - house-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
                    let dist-car-5-2-f ((destination-xcor - my-parking-xcor) ^ 2 + (destination-ycor - hw-ycor) ^ 2) ^ 0.5
                    let dist-car-5-6-f ((facility-xcor - destination-xcor) ^ 2 + (facility-ycor - destination-ycor) ^ 2) ^ 0.5
                    let dist-car-5-7-f ((facility-xcor - facility-xcor) ^ 2 + (hw-ycor - facility-ycor) ^ 2) ^ 0.5
                    let dist-car-5-8-f ((house-xcor - facility-xcor) ^ 2 + (hw-ycor - hw-ycor) ^ 2) ^ 0.5
                    let dist-car-5-9-f ((house-xcor - house-xcor) ^ 2 + (house-ycor - hw-ycor) ^ 2) ^ 0.5
                    set my-car-moving dist-car-5-0-f + dist-car-5-1-f + dist-car-5-2-f + dist-car-5-6-f + dist-car-5-7-f + dist-car-5-8-f + dist-car-5-9-f
                  ]
                ]
              ]
            ][
              set my-car-moving 0
            ]
          ]

          ifelse (linked-trip-number = 2 or linked-trip-number = 3 or linked-trip-number = 6 or linked-trip-number = 7) [
            set my-train-moving (40 * 2)
          ][
            set my-train-moving 0
          ]

          ifelse (linked-trip-number = 6 or linked-trip-number = 7 or linked-trip-number = 8 or linked-trip-number = 9) [
            set my-tram-moving t-tram-for-keep * v-tram
          ][
            set my-tram-moving 0
          ]
        ]
        set list-of-car-moving replace-item count-of-moving list-of-car-moving (round (sum [my-car-moving] of people))
        set list-of-train-moving replace-item count-of-moving list-of-train-moving (sum [my-train-moving] of people)
        set list-of-tram-moving replace-item count-of-moving list-of-tram-moving (sum [my-tram-moving] of people)

        ask people[
          ifelse OFS-location != "A: no" [
            if linked-trip-number = 0[
              let dist-0-go min (list bst-impact-dist ((((facility-xcor - destination-xcor) ^ 2) + ((facility-ycor - destination-ycor) ^ 2)) ^ 0.5))
              let dist-0-bk min (list bst-impact-dist ((((house-xcor - facility-xcor) ^ 2) + ((house-ycor - facility-ycor) ^ 2)) ^ 0.5))
              set t-around-f (dist-0-go + dist-0-bk) / v-walk
            ]
            if linked-trip-number = 1[
              let dist-1-go min (list bst-impact-dist ((((facility-xcor - destination-xcor) ^ 2) + ((facility-ycor - destination-ycor) ^ 2)) ^ 0.5))
              let dist-1-bk min (list bst-impact-dist ((((house-xcor - facility-xcor) ^ 2) + ((house-ycor - facility-ycor) ^ 2)) ^ 0.5))
              set t-around-f (dist-1-go + dist-1-bk) / v-bicycle
            ]
            if (linked-trip-number = 2 or linked-trip-number = 3)[
              let dist-23-go min (list bst-impact-dist ((((facility-xcor - destination-xcor) ^ 2) + ((facility-ycor - destination-ycor) ^ 2)) ^ 0.5))
              let dist-23-bk min (list bst-impact-dist ((((sta-b-xcor - facility-xcor) ^ 2) + ((sta-b-ycor - facility-ycor) ^ 2)) ^ 0.5))
              set t-around-f (dist-23-go + dist-23-bk) / v-walk
            ]
            if (linked-trip-number = 4 or linked-trip-number = 5)[
              ifelse (park&walk = "yes") and (((facility-xcor - sta-b-xcor) ^ 2 + (facility-ycor - sta-b-ycor) ^ 2) ^ 0.5 < p-radius)[
                let dist-45-go min (list bst-impact-dist ((((facility-xcor - destination-xcor) ^ 2) + ((facility-ycor - destination-ycor) ^ 2)) ^ 0.5))
                let dist-45-bk min (list bst-impact-dist ((((my-parking-xcor - facility-xcor) ^ 2) + ((my-parking-ycor - facility-ycor) ^ 2)) ^ 0.5))
                set t-around-f (dist-45-go + dist-45-bk) / v-walk
              ][
                set t-around-f 0
              ]
            ]
          ][
            set t-around-f 0
          ]
        ]

        set days 0
        set count-of-moving count-of-moving + 1
        ask patch sta-a-xcor sta-a-ycor [set pcolor red]
        ask patch sta-b-xcor sta-b-ycor [set pcolor red]
        if OFS-location != "A: no" [
          ask patch facility-xcor facility-ycor [set pcolor red]
        ]
        set habitation-selection-flag 0

        set sum-car-travel sum [my-car-moving] of people
        set sum-train-travel sum [my-train-moving] of people
        set sum-tram-travel sum [my-tram-moving] of people
        set CO2-emission (sum-car-travel * 14.5 + sum-train-travel * 2.0 + sum-tram-travel * 2.0 ) / (63169.1778463323 * 14.5 + 5870 * 2.0)
      ]
    ]
  ]
end
@#$#@#$#@
GRAPHICS-WINDOW
500
10
1138
649
-1
-1
3.13433
1
10
1
1
1
0
0
0
1
-100
100
-100
100
0
0
0
ticks
30.0

BUTTON
5
10
125
50
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
125
10
245
50
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

PLOT
5
275
495
550
travel-modes
tick
totals
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"0-walk" 1.0 0 -13345367 true "" "plot count people with [linked-trip-number = 0]"
"1-bicycle" 1.0 0 -1184463 true "" "plot count people with [linked-trip-number = 1]"
"2-rail (w)" 1.0 0 -10899396 true "" "plot count people with [linked-trip-number = 2]"
"3-rail (b)" 1.0 0 -11085214 true "" "plot count people with [linked-trip-number = 3]"
"4-car" 1.0 0 -2674135 true "" "plot count people with [linked-trip-number = 4]"
"5-car (hw)" 1.0 0 -2064490 true "" "plot count people with [linked-trip-number = 5]"

MONITOR
5
555
65
600
0-W
count people with [linked-trip-number = 0\n]
17
1
11

MONITOR
310
555
370
600
3-bRw
count people with [linked-trip-number = 3]
17
1
11

MONITOR
375
555
435
600
4-C
count people with [linked-trip-number = 4]
17
1
11

MONITOR
125
555
185
600
1-B
count people with [linked-trip-number = 1]
17
1
11

MONITOR
435
555
495
600
5-Ch
count people with [linked-trip-number = 5]
17
1
11

MONITOR
250
555
310
600
2-wRw
count people with [linked-trip-number = 2]
17
1
11

SLIDER
155
115
270
148
coeff-attraction
coeff-attraction
0
50
0.0
10
1
NIL
HORIZONTAL

MONITOR
305
650
420
695
cnt-house-xcor (km)
center-of-house-xcor / 10
2
1
11

CHOOSER
5
65
120
110
OFS-location
OFS-location
"A: no" "B: suburb-hw" "C: suburb" "D: same-sta" "E: near-sta" "by-slider"
0

SLIDER
5
115
120
148
OFS-xcor
OFS-xcor
-2
2
0.0
0.1
1
NIL
HORIZONTAL

SLIDER
45
150
78
265
OFS-ycor
OFS-ycor
-2
2
0.0
0.1
1
NIL
VERTICAL

MONITOR
420
650
535
695
cnt-house-ycor (km)
center-of-house-ycor / 10
2
1
11

CHOOSER
265
10
380
55
people-fig
people-fig
"visible" "invisible"
1

MONITOR
250
600
370
645
ratio-railway (%)
ratio-train * 100
2
1
11

MONITOR
5
600
120
645
ratio-walk (%)
ratio-walk * 100
2
1
11

MONITOR
125
600
245
645
ratio-bicycle (%)
ratio-bike * 100
2
1
11

MONITOR
375
600
495
645
ratio-car (%)
ratio-car * 100
2
1
11

MONITOR
555
650
670
695
sd-house-xcor (km)
sd-of-house-xcor / 10
2
1
11

MONITOR
670
650
785
695
sd-house-ycor (km)
sd-of-house-ycor / 10
2
1
11

MONITOR
5
650
140
695
CO2-emission (%)
CO2-emission * 100
1
1
11

MONITOR
155
650
290
695
average-travel-time (min)
(sum [final-t-total] of people) / n-people
2
1
11

CHOOSER
315
175
430
220
park&walk
park&walk
"yes" "no"
1

CHOOSER
315
115
430
160
bicycle-promotion
bicycle-promotion
"yes" "no"
1

TEXTBOX
315
75
450
110
combined transport policies
12
0.0
1

TEXTBOX
150
65
300
115
coefficient of attraction - level of effort to bring further street activeness
12
0.0
1

TEXTBOX
90
195
220
220
based on the central station
12
0.0
1

@#$#@#$#@
## WHAT IS IT?

This is an urban dynamics ABM of abstraction of a city and residents’ activities there.

It allows you to evaluate the effects of urban policies, such as an introduction of an open facility for residents with pedestrian-friendly accommodations, promotion of bicycle use, and control of private automobile use in an urban central area, in controlling urban sprawl.


## HOW IT WORKS

The model space is the abstraction of a part of typical cities, which have a central business district and bedroom towns connected by railway.

In the model space, the two primary domains are a residence district and a central business district. In the residence district, residences of the same number as household agents are located based on normal distribution centering on the suburban station (green patches). The residences are the starting point and the final destination of each household agent's daily travel. The number of household agents are 1,000. These correspond to 10,000 households in the real world. Similarly, in the central business district, job locations of the same number are located based on normal distribution centering on the central station (blue patches). The job locations are a halfway point of the daily travel.

Two railway stations, the suburban station and the central station, are located at the center of each district, and they are connected by a railway (dark red patches). Additionally, a highway is located north of the railway (dark green patches), and uniform and high density sidewalks and roads are located on this entire urban schematic.

Each household agent does daily travel according to the selected linked trip and fixes travel modes in one way through the learning period of repeating this daily travel 30 times. After that, a portion of the household agents relocate their residences based on the total living cost. The change in land-use pattern is brought about through these residential relocations.
After the loop process of residential relocation is repeated 20 times, the model stops running. This one process corresponds to simulating 40 years in the real world.


## HOW TO USE IT

Select the location of the open facility for stopping off (using the chooser OFS-location, the sliders OFS-xcor and OFS-ycor).

Select the coefficient of attraction (using the slider coeff-attraction).

Select the combined transport policies (using the sliders bicycle-promotion and park&walk).

Press the SETUP button.

Start the simulation by pressing the GO button. You can’t change the setting while the simulation is running.


### Buttons

SETUP - generates a new model space based on the settings of the location of the open facility for stopping off, the coefficient of attraction, and the combined transport policies. This also clears the plot. And all the monitors display the initial setting values. 

GO - runs the simulation


### Choosers

OFS-location – sets the location of an "open facility for stopping off (OFS)" in the central area or the suburb of the central business district. This is assumed to be the complex facilities that residents can visit freely in their daily life. After household agents arrive at each job location, next they leave for the OFS. And after arriving and staying the OFS, they leave for each residence.
When you choose "A: no," the OFS is not introduced. So, household agents don’t stop off in the OFS.
When you choose "B: suburb-hw," the OFS is located in suburb along highway, 0.5km north and 2km east from the central station.
When you choose "C: suburb," the OFS is located in suburb away from highway, 2km south and 0.5km east from central the station.
When you choose "D: same-sta," the OFS is located in urban central area, same place as the central station.
When you select "E: near-sta," the OFS is located in urban central area, 0.5km south and 0.5km east from the central station.
When you choose "by-slider," you can select the position of the OFS in detail by the sliders OFS-xcor and OFS-ycor.

bicycle-promotion - when you choose "yes," promotion of bicycle use is implemented in combination. By this promotion of bicycle use, the bicycle-related changes to travel are as follows:
The velocity in traveling by bicycle increased by 120%.
The fatigue cost in traveling by bicycle was reduced by 50%.
Bicycle and railway in combination users can travel by bicycle after getting off.

park&walk – when you choose "yes," control of private automobile use in an urban central area is implemented in combination. By this control of private automobile use, 10 parking lots are located along the circle within a 1.5-kilometer radius centering on the central station (yellow dots). And within this radius, private automobile users must travel on foot from the nearest parking lot to their job locations. Additionally, a highway is placed 1.5-kilometer north of a railway, and private automobile users should relocate to only the residence candidate out of this radius.

people-fig - when you choose "visible," you can observe the movement of the household agents step by step. However, the calculation load increases and the model processes slowly. If not a test, "invisible" is recommended.


### Sliders

OFS-xcor and OFS-ycor – sets the location of the OFS in detail if you choose "by-slider" of the chooser OFS-location. Each is the relative distance from the central station in the east-west direction and north-south direction, and the unit is kilometer.

coeff-attraction - sets the coefficient of attraction when the OFS is introduced.
It is assumed that street activeness can be generated when household agents, which travel on foot or by bicycle around the OFS, interact face-to-face - namely when they agglomerate geographically. And during this time, the total travel cost of relevant household agents is reduced by benefit brought about by the street activeness. The coefficient of attraction can be regarded as a level of effort to bring further street activeness according to the agglomeration of pedestrians. An increase in this coefficient enhances the benefit for travel on foot or by bicycle, reducing the total travel cost. Therefore, this coefficient can be regarded as a coefficient of gain.


### Plots

travel-modes - displays the number of household agents who travel by the following, over time:
0-walk - travel on foot throughout
1-bicycle - travel by bicycle throughout
2-rail (w) - travel by railway and on foot in combination
3-rail (b) - travel by railway, by bicycle, and on foot in combination
4-car - travel by private automobile throughout
5-car (hw) - travel by private automobile via highway


### Monitor

0-W - displays the number of household agents who travel on foot throughout
1-B - displays the number of household agents who travel by bicycle throughout
2-wRw - displays the number of household agents who travel by railway and on foot in combination
3-bRw - displays the number of household agents who travel by railway, by bicycle, and on foot in combination
4-C - displays the number of household agents who travel by private automobile throughout
5-Ch - displays the number of household agents who travel by private automobile via highway

ratio-walk (%) - displays the percentage of household agents whose representative travel mode is on foot ("0-W")
ratio-bicycle (%) - displays the percentage of household agents whose representative travel mode is by bicycle ("1-B")
ratio-railway (%) - displays the percentage of household agents whose representative travel mode is by railway ("2-wRw" and "3-bRw"). The initial value of this monitor is 100%, according to the original urban planning philosophy.
ratio-car (%) - displays the percentage of household agents whose representative travel mode is by private automobile ("4-C" and "5-Ch")

CO2-emission (%) - displays the total carbon dioxide emission relative to the basic scenario: no OFS, no pedestrian attraction, and no combined transport policy

average-travel-time (min) - displays the average travel time of all household agents, and the unit is minute

cnt-house-xcor (km) and cnt-house-ycor (km) - displays the center of residences’ distribution in the east-west direction and north-south direction based on the center of the view, and the unit is kilometer. The initial values of these monitor are -2 km and 0 km.

sd-house-xcor (km) and sd-house-ycor (km) - displays the standard deviation of residences’ distribution in the east-west direction and north-south direction, and the unit is kilometer. The initial values of these monitor are 0.8 km.


## HOW TO CITE

If you mention the NetLogo software in a publication, we ask that you include the citations below.

* Wilensky, U. (1999). NetLogo. http://ccl.northwestern.edu/netlogo/. Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
0
Rectangle -7500403 true true 151 225 180 285
Rectangle -7500403 true true 47 225 75 285
Rectangle -7500403 true true 15 75 210 225
Circle -7500403 true true 135 75 150
Circle -16777216 true false 165 76 116

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.0.2
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="0" repetitions="4" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <metric>count people with [linked-trip-number = 0]</metric>
    <metric>count people with [linked-trip-number = 1]</metric>
    <metric>count people with [linked-trip-number = 2]</metric>
    <metric>count people with [linked-trip-number = 3]</metric>
    <metric>count people with [linked-trip-number = 4]</metric>
    <metric>count people with [linked-trip-number = 5]</metric>
    <metric>count people with [linked-trip-number = 6]</metric>
    <metric>count people with [linked-trip-number = 7]</metric>
    <metric>count people with [linked-trip-number = 8]</metric>
    <metric>count people with [linked-trip-number = 9]</metric>
    <metric>sum [my-car-moving] of people</metric>
    <metric>sum [my-train-moving] of people</metric>
    <metric>sum [my-tram-moving] of people</metric>
    <metric>(sum [final-t-total] of people) / n-people</metric>
    <metric>center-of-house-xcor</metric>
    <metric>center-of-house-ycor</metric>
    <metric>sd-of-house-xcor</metric>
    <metric>sd-of-house-ycor</metric>
    <metric>(sum [cost] of people) / n-people</metric>
    <enumeratedValueSet variable="stop-off?">
      <value value="&quot;no&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coeff-attract">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bicycle-promo?">
      <value value="&quot;no&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="park&amp;walk?">
      <value value="&quot;no&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tram?">
      <value value="&quot;no&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initial-state">
      <value value="&quot;zoned&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="f-xcor">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="f-ycor">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="n-relocation">
      <value value="20"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fuel-cost">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="p-radius">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coeff-velocity">
      <value value="1.2"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coeff-fatigue">
      <value value="0.5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="day-learn">
      <value value="30"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="n-people">
      <value value="1000"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="n-candidate">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="pref-money">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="pref-fatigue">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="pref-time">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="pref-attract">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="people-fig">
      <value value="&quot;invisible&quot;"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
1
@#$#@#$#@
